
library(miscTools)
library(maxLik)


parameter_ind <- function(ivgt, ind, nc, sero, ncoeffs) {
  
  i <- 1;
  while (i <= nc) {
    j <- 1;
    while (j <= ncoeffs[i]) {
      if (i > ind) {
        ivgt <- c(ivgt, sero);
      }
      if (i < ind) {
        ivgt <- c(sero, ivgt);
      }
      j <- j+1;
    }
    i <- i+1;
  }
  
  return (ivgt);
}


gamma_outside_forecast <- function(Data, arg_inds, arg_vars, dep, fp1, ivmts, ivdts, ivgts, ivmtcs, ivdtcs, ivgtcs) {

  require(compiler);
  enableJIT(3);
  
  
  Halton_File <- arg_vars[[1]];
  output <- arg_vars[[2]];
  
  numout <<- arg_inds[[1]];         # Number of outside goods (i.e., always consumed goods)
  config <- arg_inds[[2]];          # Utility specification configuration, possible values: 1,4,5,6,7
  alp0to1 <<- arg_inds[[3]];        # 1 if you want the Alpha values to be constrained between 0 and 1, 0 otherwise
  # putting _alp0to1 = 1 is recommended practice and can provide estimation stability
  price <- arg_inds[[4]];           # 1 if there is price variation across goods, 0 otherwise
  nc <<- arg_inds[[5]];             # Number of alternatives (in the universal choice set) including outside goods
  po <<- arg_inds[[6]];      
  
  ivuno <- arg_inds[[7]];    #"uno" 
  ivsero <- arg_inds[[8]];   #"sero" 
  
  nrep <- arg_inds[[9]];
  gumbel <- arg_inds[[10]];
  hal_startline <- arg_inds[[11]];
  
  tolel <- arg_inds[[12]];
  tolee <- arg_inds[[13]];
  avg <- arg_inds[[14]];
  
  
  f  <- def;
  fp <- fp1;  #fp_ind(ivuno,nc);
  
  
  if (gumbel == 0) {
    nrep <- 1;
  }
  
  #   Data <<- read.table("D:/Class/2015/CEE_8813D/Project5/Project5EstimationFiles/MDCEV Model/mdcev_full2.csv", header=T, sep=","); 
  #   Halton_File <<- "D:/Class/2015/CEE_8813D/Project5/MDCEV_Forecasting/halton_class15.csv";
  #   output <- "D:/Class/2015/CEE_8813D/Project5/MDCEV_Forecasting/test_gamma_output.csv";
  #   
  #   uno <- 5; #"uno"; # Column of ones
  #   sero <- 6; #"sero"; # Column of zeros
  #   
  #   po <- 4; # Column number of the unique identifier created for a household (this column is created by the user)
  #   nrep <- 1;  # Number of replications of the MDCEV model to be carried out
  #   
  #   numout <- 1;
  #   config <- 4;    #Utility specification configuration, possible values: 1,4,5,6,7
  #   alp0to1 <- 1;    #1 if you want the Alpha values to be constrained between 0 and 1, 0 otherwise
  #   #putting _alp0to1 = 1 is recommended practice and can provide estimation stability
  #   price <- 0;       #1 if there is price variation across goods, 0 otherwise
  #   hal_startline <- 22;
  #   
  #   
  #   nc <- 15;        #Number of alternatives (in the universal choice set) including outside goods
  #   gumbel <- 1;
  #   
  #   
  #   if (gumbel == 0) {
  #     nrep <- 1;
  #   }
    
  #   tolel <- 0.00000001;
  #   tolee <- 0.01;
  #   avg <<- 0;
    
  #   f <- c("home","PerBus1","PerBus2","Shop1","Shop2","Shop3","Social1","Social2","Rec1","Rec2","Meal1","Meal2","Serve1","Serve2","Other1");
  #   fp <- c(rep(uno,nc));
  

  
  ########################################################
  #    Do not modify the line below####################### 
  
  #ivmts_coef <- c(b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12,b13,b14,b15);
  #ivgts_coef <- c(g2,g3,g4,g5,g6,g7,g8,g9,g10,g11,g12,g13,g14,g15);

  b_ivmtc <- NULL; #c(ivmtcs[[2]]);
  for(i in (numout+1):nc){
    b_ivmtc <- c(b_ivmtc, ivmtcs[[i]]);
  }
  
  b_ivgtc <- c(ivgtcs[[1]]);
  for(i in 2:nc){
    b_ivgtc <- c(b_ivgtc, ivgtcs[[i]]);
  }
  
  bmdcev <- matrix(c(b_ivmtc, ivdtcs, b_ivgtc, 1.0), ncol=1);


  
  #Associating columns with variable names
  flagchm <<- def;        
  flagavm <<- fp; #ivuno~ivuno~ivuno;  //Append as many "ivuno" as the number of alternatives
  flagprcm <<- fp;


  #### Baseline utility equation
  ivmt <- ivmts;
  
  ncoeffs <- NULL;
  for(i in (numout+1):nc){
    ncoeffs <- c(ncoeffs, length(ivmt[[i]]));
  }
  
  for(i in 1:numout){ 
    tmp1 <- c(ivsero);
    for(j in 2:sum(ncoeffs)){
      tmp1 <- c(tmp1,ivsero);
    }
    ivmt[[i]] <- tmp1;
  }
  
  for(i in (numout+1):nc){
    ivmt[[i]] <- parameter_ind(ivmt[[i]], (i-numout), (nc-1), ivsero, ncoeffs);
  }


  #### Satiation parameter (alpha) specification
  ncoeffs <- c(length(ivdts[[1]]));
  for(i in 2:nc){
    ncoeffs <- c(ncoeffs, length(ivdts[[i]]));
  }
  
  ivdt <- list();
  for (i in 1:nc){
    ivdt1 <- ivdts[[i]];  
    ivdt[[i]] <- parameter_ind(ivdt1, i, nc, ivsero, ncoeffs);
  }
  
  
  #### translation parameter (gamma) specification
  ncoeffs <- NULL; 
  for(i in 1:nc){
    ncoeffs <- c(ncoeffs, length(ivgts[[i]]));
  }
  
  ivgt <- list();
  for(i in 1:nc){
    ivgt1 <- ivgts[[i]];
    ivgt[[i]] <- parameter_ind(ivgt1, i, nc, ivsero, ncoeffs);
  }

  

  #ivm <<- c(ivmt1, ivmt2, ivmt3, ivmt4, ivmt5, ivmt6, ivmt7, ivmt8, ivmt9, ivmt10, ivmt11, ivmt12, ivmt13, ivmt14, ivmt15);
  ivm <<- c(ivmt[[1]]);
  for (i in 2:(length(ivmt))){
    ivm <<- c(ivm, ivmt[[i]]);
  }
  print(ivm);
  
  #ivd <<- c(ivdt1, ivdt2, ivdt3, ivdt4, ivdt5, ivdt6, ivdt7, ivdt8, ivdt9, ivdt10, ivdt11, ivdt12, ivdt13, ivdt14, ivdt15);
  ivd <<- c(ivdt[[1]]);
  for (i in 2:(length(ivdt))){
    ivd <<- c(ivd, ivdt[[i]]);
  }
  
  #ivg <<- c(ivgt1, ivgt2, ivgt3, ivgt4, ivgt5, ivgt6, ivgt7, ivgt8, ivgt9, ivgt10, ivgt11, ivgt12, ivgt13, ivgt14, ivgt15);
  ivg <<- c(ivgt[[1]]);
  for (i in 2:(length(ivgt))){
    ivg <<- c(ivg, ivgt[[i]]);
  }
  

  nvarm <<- length(ivmt[[1]]);      #number of variables in baseline utility   = number of columns in ivm1, do not modify this
  nvardel <<- length(ivdt[[1]]);    #number of variables in satiation          = number of columns in ivd1, do not modify this
  nvargam <<- length(ivgt[[1]]);    #number of variables in translation        = number of columns in ivg1, do not modify this
  
  
  #Do not modify the line below####################### 
  if (config == 1) {
    eqmatdel <- diag(nvardel);
    eqmatgam <- rbind(matrix(1,nrow=1,ncol=numout),matrix(0,nrow=1,ncol=numout));
    eqmatgam <- cbind(eqmatgam, rbind(matrix(0,nrow=1,ncol=(nc-numout)),matrix(1,nrow=1,ncol=(nc-numout))));
  }
  if (config == 4) {
    eqmatdel <- matrix(1,nrow=1,ncol=nc);
    eqmatgam <- diag(nvargam);
  }
  if (config == 5) {
    eqmatdel <- matrix(1,nrow=1,ncol=nvardel);
    eqmatgam <- diag(nvargam);
  }
  if (config == 6) {
    eqmatdel <- rbind(matrix(1,nrow=1,ncol=numout),matrix(0,nrow=1,ncol=numout));
    eqmatdel <- cbind(eqmatdel, rbind(matrix(0,nrow=1,ncol=(nc-numout)),matrix(1,nrow=1,ncol=(nc-numout))));
    eqmatgam <- diag(nc);
  }
  if (config == 7) {
    eqmatdel <- matrix(1,nrow=1,ncol=nc);
    eqmatgam <- diag(nc);
  }
  
  
  
  
  forec <- function(x) {
    
    ptm1 <- proc.time();
    
    e1 <- nrow(Data);
    popass <- as.matrix(Data[,po]);
    
    
    xdel <- t(eqmatdel)%*%x[(nvarm+1):(nvarm+nrow(eqmatdel)),];
    xgam <- t(eqmatgam)%*%x[(nvarm+nrow(eqmatdel)+1):(nvarm+nrow(eqmatdel)+nrow(eqmatgam)),];
    xsigm <- x[(nvarm+nrow(eqmatdel)+nrow(eqmatgam)+1),];
    
    a <- matrix(c(rep(1,nc)), ncol=1)%x%x[1:nvarm,];
    b <- matrix(c(rep(1,nc)), ncol=1)%x%xdel;
    c <- matrix(c(rep(1,nc)), ncol=1)%x%xgam;
    
    v2 <- sweep(Data[,ivm],MARGIN=2,t(a),'*');
    w2 <- sweep(Data[,ivd],MARGIN=2,t(b),'*');
    u2 <- sweep(Data[,ivg],MARGIN=2,t(c),'*');
    rm(a, b, c);
    
    
    v <- NULL;
    w <- NULL;
    u <- NULL;
    alts <- matrix(0,nrow=1,ncol=nc);
    for (j in 1:nc) {
      #v <- cbind(v, as.matrix(apply(v2[,((j-1)*nvarm+1):(j*nvarm)],1,sum),ncol=1));
      #w <- cbind(w, as.matrix(apply(w2[,((j-1)*nvardel+1):(j*nvardel)],1,sum),ncol=1));
      #u <- cbind(u, as.matrix(apply(u2[,((j-1)*nvargam+1):(j*nvargam)],1,sum),ncol=1));
      
      v <- cbind(v, as.matrix(rowSums(v2[,((j-1)*nvarm+1):(j*nvarm)]),ncol=1));
      w <- cbind(w, as.matrix(rowSums(w2[,((j-1)*nvardel+1):(j*nvardel)]),ncol=1));
      u <- cbind(u, as.matrix(rowSums(u2[,((j-1)*nvargam+1):(j*nvargam)]),ncol=1));
      
      alts[1,j] <- j;
    }
    u[,1:numout] <- -1000*matrix(1,nrow=e1,ncol=numout);
    rm(v2, w2);
    v <- exp(v);
    v <- kronecker(v,matrix(1,nrow=nrep,ncol=1));
    
    if (gumbel == 1) {
      print("Gumbel error terms are used to simulate the unobserved heterogeneity.");
      #as <- halton(nrep*e1, dim = nc, init = TRUE, normal = FALSE, usetime = FALSE)
      as <- read.table(Halton_File, header=F, sep=",");
      as <- as.matrix(as[hal_startline:(e1*nrep+(hal_startline-1)),1:nc]);
      as <- -log(-log(as))*xsigm;
    }
    else {
      print("no error terms are used for forecasting.");
      as <- matrix(0,nrow=(nrep*e1),ncol=nc);
    }
    
    
    v <- v*exp(as);
    tmp <- kronecker(as.matrix(Data[,flagprcm]),matrix(1,nrow=nrep,ncol=1));
    v <- v/tmp ;   # Price-normalized Baseline Utilities
    rm(tmp);
    a <- 1-(1/(1+exp(w))) ;        # Alphas
    prices <- as.matrix(Data[,flagprcm]);
    f1 <- exp(u);                # Gammas  
    
    
    
    for (i in 1:e1) {
      for (j in 1:nrep) {
        fc <- matrix(0,nrow=1,ncol=nc);
        vqr <- rbind(alts,rbind(v[((i-1)*nrep+j),],rbind(prices[i,],f1[i,])));
        
        vqr1 <- vqr[,1:numout];
        vqr2 <- vqr[,(numout+1):nc];
        vqr <- cbind(vqr1,vqr2[,order(vqr2[2,],decreasing = TRUE)]);
        
        m <- numout;
        k <- -1;
        N <- rowSums(t(prices[i,1:numout]*((vqr[2,1:numout])^(1/(matrix(1,nrow=1,ncol=numout)-a[1,1:numout])))));
        D <- colSums(t(Data[i,flagchm]));
        
        lambda <- (N/D)^(1-a[1,1]);     
        
        if (vqr[2,(numout+1)] < lambda) {
          fc[1,1:numout] <- ((vqr[2,1:numout]/lambda)^(1/(matrix(1,nrow=1,ncol=numout) - a[1,1:numout])));
          fc[1,(numout+1):nc] <- matrix(0,nrow=1,ncol=(nc-1));
        }
        else{
          while (m != k){
            
            m <- m+1;
            if (m == nc) {            
              fc[1,1:numout] <- ((vqr[2,1:numout]/lambda)^(1/(1-a[1,1:numout])));
              fc[1,(numout+1):nc] <- (((vqr[2,(numout+1):nc]/lambda)^(1/(1-a[1,(numout+1):nc])))-matrix(1,nrow=1,ncol=(nc-numout)))*(vqr[4,(numout+1):nc]);
              fc[1,1:nc] <- colSums(t(Data[i,flagchm]))*fc[1,1:nc]/rowSums(t(fc[1,1:nc]));
              k <- m;
            }
            else if (m < nc){
              N <- N + (vqr[4,m]*vqr[3,m]*(vqr[2,m]^(1-a[1,1])));
              D <- D + (vqr[4,m]*vqr[3,m]);
              lambda <- (N/D)^(1-a[1,1]);
              
              if (vqr[2,m+1] < lambda){
                fc[1,1:numout] <- ((vqr[2,1:numout]/lambda)^(1/(1-a[1,1:numout])));
                fc[1,(numout+1):m] <- (((vqr[2,(numout+1):m]/lambda)^(1/(1-a[1,(numout+1):m])))-matrix(1,nrow=1,ncol=(m-numout)))*(vqr[4,(numout+1):m]);
                fc[1,(m+1):nc] <- matrix(0,nrow=1,ncol=(nc-m));
                k <- m;
              }
            }
          }
          
        }
        
        vqr[2,1:nc] <- fc;
        vqr <- vqr[,order(vqr[1,])];
        v[((i-1)*nrep+j),1:nc] <- vqr[2,];
      }
      
    }
    nreps = NULL;
    for (i in 1:nrep) {
      nreps = rbind(nreps, i);
    }
    
    z1 <- kronecker(popass,matrix(1,nrow=nrep,ncol=1));
    z2 <- kronecker(matrix(1,nrow=nrow(popass),ncol=1),nreps);
    z <- cbind(z1,z2);
    z <- cbind(z,v);
    rm(z1,z2);
    return(z);
    
  }
  
  
  Forecasts <- forec(bmdcev);
  nobs <- nrow(Data);
  if (avg == 1) {
    
    mdcev <- NULL;
    for (ii in 0:(nobs-1)) {
      mdcev <- rbind(mdcev,colSums(Forecasts[(ii*nrep+1):(ii*nrep+nrep),]/nrep)); 
    }
    mdcev <- as.data.frame(mdcev); 
    print("Done!");
  }
  if (avg == 0) {
    print("Done!");
    mdcev <- Forecasts;
    mdcev <- as.data.frame(mdcev);
  }
  rm(Forecasts);
  
  names(mdcev) <- c("ID","Replication",f);
  write.table(mdcev, file = output, row.names=FALSE, sep=",");
  
  
}



